# TeleNVDA #

* Автори: Asociación Comunidad Hispanohablante de NVDA и други
  сътрудници. Първоначална разработка от Tyler Spivey и Christopher Toth
* Съвместимост с NVDA: от 2019.3 и по-нови версии
* Изтегляне на [стабилна версия][1]

Забележка: за да улесним изтеглянето за потребители, които се нуждаят от
помощ или обучение и имат ограничени компютърни умения, ние предоставяме
алтернативна връзка към най-новата стабилна версия, която е лесна за
запомняне и споделяне. Можете да отидете на
[nvda.es/tele](https://nvda.es/tele) и да изтеглите добавката директно, без
междинни уеб страници.

Добре дошли в добавката TeleNVDA, която ще ви позволи да се свържете с друг
компютър, работещ с безплатния екранен четец NVDA. С тази добавка можете да
се свържете с компютъра на друг човек или да позволите на доверено лице да
се свърже с вашата система, за да извърши рутинна поддръжка, да
диагностицира проблем или да извърши обучение. Тази добавка е модифицирана
версия на [добавката NVDA Remote](https://nvdaremote.com) и се поддържа от
испанската общност на NVDA. Тя е напълно съвместима с NVDA Remote. Това са
текущите разлики:

* Опция позволява блокиране на дистанционни речеви команди, различни от
  текст.
* Подобрена поддръжка за прокси сървъри и скрити услуги на TOR (необходима е
  [добавката за поддръжка на
  прокси](https://addons.nvda-project.org/addons/proxy.en.html)).
* Възможност за замяна на клавиша F11 с друг жест. Сега това работи като общ
  скрипт, така че можете да задавате жестове в диалоговия прозорец "Жестове
  на въвеждане".
* Възможност за пълно игнориране на следващия жест – полезно е, ако трябва
  да изпратите до отдалечената машина жеста, използван за превключване между
  управляващата и управляваната машина.
* Възможност за обмен на малки файлове (до 10 МБ) между потребители,
  свързани към една и съща сесия.
* Възможност за пренасочване на портове през UPNP.
* Възможност за използване на услуга по избор за проверка на портове.
* Разни промени по ГПИ (графичния потребителски интерфейс).
* Отстранени са други разни грешки.

## Преди да започнете

Ще трябва да сте инсталирали NVDA и на двата компютъра и да се сдобиете с
добавката TeleNVDA.

Инсталирането както на NVDA, така и на добавката TeleNVDA е стандартно. Ако
имате нужда от повече информация, можете да я намерите в Ръководството на
потребителя на NVDA.

## Обновяване

Когато обновявате добавката, ако сте инсталирали TeleNVDA за защитени
екрани, се препоръчва да обновите и копието за защитени екрани.

За да направите това, първо обновете инсталираната добавка. След това
отворете менюто на NVDA -> Настройки -> Опции -> Основни и натиснете бутона
с етикет "Използвай текущо запазените настройки в екрана за вписване и
другите защитени екрани (изисква административни права)".

## Стартиране на отдалечена сесия през препредаващ сървър

### На управлявания компютър

1. Отворете менюто на NVDA -> Инструменти -> Отдалечен достъп -> Свържи. Или
   директно натиснете NVDA+Alt+Page Up. Този жест може да бъде променен в
   диалоговия прозорец "Жестове на въвеждане" на NVDA.
2. Изберете "Клиент" в първата група от радио бутони.
3. Изберете "Разрешаване на управлението на тази машина" във втората група
   от радио бутони.
4. В полето "Хост" въведете хоста на сървъра, към който се свързвате,
   например remote.nvda.es. Когато конкретният сървър използва алтернативен
   порт, можете да въведете хоста във формата &lt;хост&gt;:&lt;порт&gt;,
   например remote.nvda.es:1234. Ако се свързвате към IPv6 адрес, въведете
   го в квадратни скоби, например [2603:1020:800:2::32].
5. Въведете ключ в полето за ключ или натиснете бутона за генериране на
   ключ. Ключът е това, което ще използват другите, за да контролират вашия
   компютър. Управляваната машина и всички нейни клиенти трябва да използват
   един и същ ключ.
6. Натиснете OK. След като приключите, ще чуете тон и ще се свържете. Ако
   сървърът включва съобщение за деня, то ще се покаже в диалогов
   прозорец. Ще виждате този диалог всеки път, когато се свържете или само
   първия път, в зависимост от конфигурацията на сървъра.

### На управляващата машина

1. Отворете менюто на NVDA -> Инструменти -> Отдалечен достъп -> Свържи. Или
   директно натиснете NVDA+Alt+Page Up. Този жест може да бъде променен в
   диалоговия прозорец "Жестове на въвеждане" на NVDA.
2. Изберете "Клиент" в първата група от радио бутони.
3. Изберете "Управляване на друга машина" във втората група от радио бутони.
4. В полето "Хост" въведете хоста на сървъра, към който се свързвате,
   например remote.nvda.es. Когато конкретният сървър използва алтернативен
   порт, можете да въведете хоста във формата &lt;хост&gt;:&lt;порт&gt;,
   например remote.nvda.es:1234. Ако се свързвате към IPv6 адрес, въведете
   го в квадратни скоби, например [2603:1020:800:2::32].
5. Въведете ключ в полето за ключ или натиснете бутона за генериране на
   ключ. Управляваната машина и всички нейни клиенти трябва да използват
   един и същ ключ.
6. Натиснете OK. След като приключите, ще чуете тон и ще се свържете. Ако
   сървърът включва съобщение за деня, то ще се покаже в диалогов
   прозорец. Ще виждате този диалог всеки път, когато се свържете или само
   първия път, в зависимост от конфигурацията на сървъра.

### Предупреждение за сигурността на връзката

Ако се свържете към сървър без валиден SSL сертификат, ще получите
предупреждение за сигурността на връзката.

Това може да означава, че връзката ви е несигурна. Ако имате доверие на
отпечатъка на този сървър, можете да натиснете "Свържи се", за да се
свържете веднъж, или "Свържи се и не питай отново за този сървър", за да се
свържете и да запазите данните за сървъра.

## Директни връзки

Опцията за сървър в диалоговия прозорец за свързване ви позволява да
настроите директна връзка.

След като изберете това, изберете в кой режим ще бъде вашият край на
връзката.

Другият човек ще се свърже с вас, използвайки обратното.

След като режимът е избран, можете да използвате бутона "Извлечи външния IP
адрес", за да получите вашия външен IP адрес и да се уверите, че портът,
който е въведен в полето за порт, е пренасочен правилно. Ако е активирано на
вашия рутер, можете да препратите порта чрез UPNP, преди да извършите
проверка на порта.

Ако системата за проверка на порта открие, че вашият порт (6837 по
подразбиране) не е достъпен, ще се изведе предупреждение.

Препратете вашия порт и опитайте отново. Също така се уверете, че процесът
на NVDA е разрешен през защитната стена на Windows.

Забележка: Процесите по препращане на портове, активиране на UPNP или
конфигуриране на защитна стена на Windows са извън обхвата на този
документ. Моля, консултирайте се с информацията, предоставена с вашия рутер,
за допълнителни инструкции.

Въведете ключ в полето за ключ или натиснете бутона "Генерирай". Другият
човек ще се нуждае от вашия външен IP заедно с ключа, за да се свърже. Ако
сте въвели порт, различен от стандартния (6837) в полето за порт, уверете
се, че другият човек добавя алтернативния порт към адреса на хоста във
формата &lt;външен ip&gt;:&lt;порт&gt;.

Ако искате да препратите избрания порт чрез UPNP, поставете отметка в
квадратчето "Използвай UPNP за пренасочване на този порт, ако е възможно".

След като задействате OK, ще бъдете свързани. Когато другият човек се
свърже, можете да използвате TeleNVDA по обичайния начин.

## Управление на отдалечената машина

След като сесията е свързана, потребителят на управляващата машина може да
натисне F11, за да започне да контролира отдалечената машина (напр. чрез
изпращане на клавишни команди или брайлов вход). Този жест може да бъде
променен от диалоговия прозорец "Жестове на въвеждане" на NVDA.

Когато NVDA съобщи "Управлява се отдалечената машина", клавишните и
брайловите команди , които натиснете, ще отидат до отдалечената
машина. Освен това, когато управляващата машина използва брайлов дисплей, на
него ще се показва информация от отдалечената машина. Натиснете F11 отново,
за да спрете да изпращате команди и да превключите обратно към управляващата
машина.

За най-добра съвместимост, моля, уверете се, че клавиатурните подредби на
двете машини съвпадат.

## Споделяне на вашата сесия

За да споделите връзка, така че някой друг да може лесно да се присъедини
към вашата сесия на TeleNVDA, изберете "Копирай връзка" от менюто за
отдалечен достъп. Можете също така да зададете жестове от диалоговия
прозорец "Жестове на въвеждане" на NVDA, за да ускорите тази процедура.

Можете да избирате между два формата на връзката. Първият е съвместим както
с NVDA Remote, така и с TeleNVDA и е най-препоръчителният за
момента. Вторият е съвместим само с TeleNVDA.

Ако сте свързани като управляващ компютър, тази връзка ще позволи на някой
друг да се свърже и да бъде управляван.

Ако вместо това сте настроили компютъра си да бъде управляван, връзката ще
позволи на хората, с които я споделяте, да управляват вашата машина.

Много приложения ще позволят на потребителите да активират тази връзка
автоматично, но ако не се стартира от конкретно приложение, може да се
копира в клипборда и да се стартира от диалоговия прозорец "Изпълнение".

Имайте предвид, че споделената връзка може да не работи, ако я копирате от
сървър, работещ в режим на директна връзка.

## Изпращане на Control+Alt+Delete

Докато изпращате команди, обикновено не е възможно да изпратите комбинацията
Control+Alt+Delete.

Ако трябва да изпратите Control+Alt+Delete и отдалечената система е на
защитен екран, използвайте тази команда.

## Изпращане на превключващи клавиши между управляващ и управляван компютър

Обикновено, когато натиснете зададения жест за превключване между локалната
и отдалечената машина, той няма да бъде изпратен до отдалечената машина –
вместо това ще превключва между локалната машина и отдалечената машина.

Ако трябва да изпратите този или друг жест към отдалечената машина, можете
да отмените това поведение за следващия незабавен жест, като активирате
скрипта за игнориране на следващия жест.

По подразбиране този скрипт е зададен на клавишната комбинация
Control+F11. Този жест може да бъде променен от диалоговия прозорец "Жестове
на въвеждане" на NVDA.

Когато този скрипт бъде извикан, следващият жест ще бъде игнориран и ще бъде
изпратен до отдалечената машина, включително жеста за активиране на скрипта
за игнориране на следващия жест. След като бъде изпратен следващият жест,
системата ще се върне към обичайното поведение.

## Отдалечено управление на необслужван компютър

Понякога може да пожелаете да контролирате един от собствените си компютри
дистанционно. Това е особено полезно, ако пътувате и искате да контролирате
домашния си компютър от лаптопа. Или може да искате да управлявате компютър
в една стая на къщата си, докато седите навън с друг компютър. Малко
предварителна подготовка прави това лесно и възможно.

1. Влезте в менюто на NVDA и изберете Инструменти, след това "Отдалечен
   достъп". Накрая натиснете Enter върху Опции.
2. Поставете отметка в полето "Автоматично се свързвай към управляващия
   сървър при стартиране".
3. Изберете дали да използвате отдалечен сървър за предаване или локално да
   хоствате връзката. Ако решите да хоствате връзката, можете да опитате да
   препратите портове с помощта на UPNP, като поставите отметка в
   съответното квадратче.
4. Изберете "Разрешаване на управлението на тази машина" във втората група
   от радио бутони.
5. Ако сами хоствате връзката, ще трябва да се уверите, че портът, въведен в
   полето за порт (6837 по подразбиране) на управляваната машина, може да
   бъде достъпен от управляващите машини.
6. Ако желаете да използвате препредаващ сървър, попълнете и двете полета
   Хост и Ключ, натиснете Tab до OK и натиснете Enter. Опцията за генериране
   на ключ не е налична в тази ситуация. Най-добре е да измислите ключ,
   който ще запомните, за да можете лесно да го използвате от всяко
   отдалечено място.

За напреднала употреба можете също да конфигурирате NVDA Remote за
автоматично свързване към локален или отдалечен сървър за предаване в режим
на управление. Ако искате това, изберете "Управляване на друга машина" във
втората група от радио бутони.

Забележка: Опциите за автоматично свързване при стартиране в диалоговия
прозорец с опции не се прилагат, докато NVDA не се рестартира.

## Заглушаване на речта на отдалечения компютър

Ако не желаете да чувате речта на отдалечения компютър или специфичните за
NVDA звуци, просто влезте в менюто на NVDA, Инструменти и Отдалечен
достъп. Със стрелка надолу отидете до "Заглуши отдалечения достъп" и
натиснете Enter. Моля, обърнете внимание, че тази опция няма да деактивира
отдалечения брайлов изход към управляващия дисплей, когато управляващата
машина изпраща команди.

## Прекратяване на отдалечена сесия

За да прекратите отдалечена сесия, направете следното:

1. На управляващия компютър натиснете F11, за да спрете управлението на
   отдалечената машина. Трябва да чуете или прочетете съобщението:
   "Управлява се локалната машина". Ако вместо това чуете или прочетете
   съобщение, че управлявате отдалечената машина, натиснете F11 още веднъж.
2. Отворете менюто на NVDA, след това Инструменти -> Отдалечен достъп и
   натиснете Enter върху "Прекъсни".

Като алтернатива можете да натиснете NVDA+Alt+Page Down, за да прекъснете
директно сесията. Този жест може да бъде променен в диалоговия прозорец
"Жестове на въвеждане" на NVDA. За да защитите другия край, можете да
натиснете този жест, докато изпращате команди, за да прекъснете връзката с
отдалечения компютър.

## Прехвърляне на клипборда

Опцията "Прехвърли клипборда" в менюто "Отдалечен достъп" ви позволява да
изпращате текст от вашия клипборд.

Когато се активира, всеки текст в клипборда ще бъде изпратен към другите
машини.

## Прехвърляне на файлове

Опцията "Изпрати файл" в менюто "Отдалечен достъп" ви позволява да изпращате
малки файлове до всички членове на сесията, включително контролираната
машина. Моля, имайте предвид, че можете да изпращате само файлове, по-малки
от 10 МБ. Изпращането или получаването на файлове на защитени екрани не е
разрешено.

Също така имайте предвид, че изпращането на файлове може да изразходва
твърде много мрежов трафик на сървъра, в зависимост от размера на файла,
компютрите, свързани към една и съща сесия, и количеството на изпратените
файлове. Свържете се с администратора на вашия сървър и го попитайте дали
трафикът се таксува. В такъв случай обмислете използването на друга
платформа за обмен на файлове.

Когато файлът бъде получен на отдалечените машини, ще се появи диалогов
прозорец "Запиши като", който ви позволява да изберете къде да запишете
файла.

## Конфигуриране на TeleNVDA за работа на защитени екрани

За да може TeleNVDA да работи на защитени екрани, добавката трябва да бъде
инсталирана в копието на NVDA, работещо на защитени екрани.

1. От менюто на NVDA изберете Настройки, след това Основни настройки.
2. Отидете с TAB до бутона "Използвай текущо запазените настройки в екрана
   за вписване и другите защитени екрани (изисква административни права)" и
   натиснете Enter.
3. Отговорете с ДА на подканите относно копирането на вашите настройки и
   относно копирането на добавки и отговорете на подканата за контрол на
   потребителските акаунти, която може да се появи.
4. Когато настройките бъдат копирани, натиснете Enter, за да задействате
   бутона OK. Отидете с TAB до OK и Enter още веднъж, за да излезете от
   диалоговия прозорец.

След като TeleNVDA бъде инсталирана за защитени екрани, ако в момента сте
контролирани в отдалечена сесия, ще имате речев и брайлов достъп до
защитения екран, когато преминете към него.

## Изчистване на отпечатъците за SSL сертификат

Ако вече не се доверявате на отпечатъците на даден сървър, на които сте
имали доверие, можете да изчистите всички отпечатъци, като задействате
бутона "Изтрий всички доверени сървърни отпечатъци" в диалоговия прозорец
"Опции".

## Използване на услуга по избор за проверка на портове

По подразбиране TeleNVDA проверява отворените портове, като използва услуга,
предоставена от испанската общност на NVDA. Можете да промените URL адреса
на услугата от диалоговия прозорец с опции. Уверете се, че портът за
проверка е част от персонализирания URL адрес и резултатите се връщат в
очаквания формат. Примерен скрипт за проверка на портове се разпространява в
хранилището на TeleNVDA, така че можете да хоствате свое собствено копие,
ако желаете.

## Промяна на TeleNVDA

Този проект се покрива от GNU General Public License, версия 2 или
по-нова. Можете да клонирате [това хранилище][2], за да направите промени по
TeleNVDA, при условие че сте прочели, разбрали и спазвате лицензионните
условия. Модулът MiniUPNP е лицензиран съгласно клаузите на лиценза BSD-3.

### Зависимости от трети страни

Те могат да бъдат инсталирани чрез pip:

* Markdown
* scons

За да компилирате изпълнимия файл за обработка на URL адреси, имате нужда от
Visual Studio 2019 или по-нова версия.

### За пакетиране на добавката за разпространение:

1. Отворете команден ред и преминете към кореновата директория на [това
   хранилище][2]
2. Изпълнете командата **scons**. Създадената добавка, ако няма грешки, се
   поставя в текущата директория.

[[!tag dev stable]]

[1]: https://www.nvaccess.org/addonStore/legacy?file=TeleNVDA

[2]: https://github.com/nvda-es/TeleNVDA
