# TeleNVDA #

* Авторы: Ассоциация испаноязычного сообщества NVDA и другие
  участники. Исходная работа: Tyler Spivey и Christopher Toth
* Совместимость с NVDA: 2019.3 и выше
* Загрузить [стабильную версию][1]

Примечание: чтобы упростить загрузку для пользователей, нуждающихся в помощи
или обучении и имеющих ограниченные навыки работы с компьютером, мы
предоставляем альтернативную ссылку на последнюю стабильную версию, которую
легко запомнить и которой легко поделиться. Вы можете перейти на
[nvda.es/tele](https://nvda.es/tele) и скачать дополнение напрямую, без
промежуточных web-страниц.

Добро пожаловать в дополнение TeleNVDA, которое позволит вам подключиться к
другому компьютеру, на котором запущена бесплатная программа экранного
доступа NVDA. С помощью этого дополнения вы можете подключаться к компьютеру
другого человека или разрешить доверенному лицу подключиться к вашей системе
для выполнения технического обслуживания, диагностики проблем или проведения
обучения. Это дополнение представляет собой модифицированную версию
[дополнения NVDA Remote](https://nvdaremote.com) и поддерживается испанским
сообществом NVDA. Оно полностью совместимо с NVDA Remote. На данный момент
имеются следующие различия:

* Опциональная возможность блокировки удалённых речевых команд отличных от
  обычного текста.
* Улучшенная поддержка proxy-серверов и скрытых сервисов TOR (требуется
  [дополнение Proxy
  support](https://addons.nvda-project.org/addons/proxy.ru.html)).
* Возможность изменить клавишу F11 на другую клавишу или сочетание
  клавиш. Теперь это работает как обычный скрипт, поэтому можно просто
  назначить желаемый жест в диалоговом окне «Жесты ввода».
* Возможность полностью игнорировать следующий непосредственный жест. Это
  полезно, если вам нужно отправить на удалённый компьютер жест,
  используемый для переключения между локальной и удалённой машиной.
* Возможность обмена небольшими файлами (до 10 МБ) между пользователями,
  подключёнными к одной сессии.
* Возможность перенаправления портов через службу UPnP.
* Возможность использования пользовательского сервиса проверки портов.
* Некоторые улучшения графического интерфейса.
* Исправление некоторых ошибок.

## Прежде чем начать

Вам нужно будет установить NVDA на оба компьютера и получить дополнение
TeleNVDA.

Установка как NVDA, так и дополнения TeleNVDA стандартна. Если вам нужна
дополнительная информация, её можно найти в руководстве пользователя NVDA.

## Обновление

Если вы ранее устанавливали TeleNVDA для работы на безопасном рабочем столе,
то после обновления дополнения, рекомендуется повторно выполнить данную
установку.

Для этого сначала следует обновить уже установленное дополнение, а затем в
категории «Общие» диалога настроек NVDA, нажать кнопку «Использовать
последнюю сохранённую конфигурацию на экране входа в систему и на других
защищённых экранах (требуются права администратора)».

## Запуск сеанса удалённого доступа через управляющий сервер

### На управляемом компьютере

1. Откройте меню NVDA → Сервис → Удалённое управление → Подключиться... Или
   нажмите NVDA+Alt+PageUp. Это сочетание может быть изменено в диалоге
   «Жесты ввода».
2. В первой паре радиокнопок выберите «Клиент».
3. Во второй паре радиокнопок выберите «Разрешить управление этим
   компьютером».
4. В поле «Адрес сервера» введите адрес сервера, к которому вы
   подключаетесь, например nvdaremote.ru. Если этот сервер использует
   нестандартный порт, то вы можете указать его через двоеточие в формате
   &lt;адрес&gt;:&lt;порт&gt;, например nvdaremote.ru:1234. Если вы
   подключаетесь к IPV6-адресу, введите его в квадратных скобках, например
   [2603:1020:800:2::32].
5. Придумайте и введите ключ в поле «Ключ» или нажмите кнопку «Создать
   ключ». Ключ это идентификатор, который другие будут использовать для
   подключения к вашему компьютеру. Управляемый компьютер и все его клиенты
   должны использовать один и тот же ключ.
6. Далее нажмите кнопку OK. Вы услышите короткий звуковой сигнал, сообщающий
   об успешном подключении. Если сервер предоставляет так называемое
   «Сообщение дня» (MOTD), оно будет показано в отдельном диалоговом
   окне. Вы будете видеть это окно при каждом подключении или только при
   первом подключении, в зависимости от конфигурации сервера.

### На управляющем компьютере

1. Откройте меню NVDA → Сервис → Удалённое управление → Подключиться... Или
   нажмите NVDA+Alt+PageUp. Это сочетание может быть изменено в диалоге
   «Жесты ввода».
2. В первой паре радиокнопок выберите «Клиент».
3. Во второй паре радиокнопок выберите «Управлять другим компьютером».
4. В поле «Адрес сервера» введите адрес сервера, к которому вы
   подключаетесь, например nvdaremote.ru. Если этот сервер использует
   нестандартный порт, то вы можете указать его через двоеточие в формате
   &lt;адрес&gt;:&lt;порт&gt;, например nvdaremote.ru:1234. Если вы
   подключаетесь к IPV6-адресу, введите его в квадратных скобках, например
   [2603:1020:800:2::32].
5. Придумайте и введите ключ в поле «Ключ» или нажмите кнопку «Создать
   ключ». Управляемый компьютер и все его клиенты должны использовать один и
   тот же ключ.
6. Далее нажмите кнопку OK. Вы услышите короткий звуковой сигнал, сообщающий
   об успешном подключении. Если сервер предоставляет так называемое
   «Сообщение дня» (MOTD), оно будет показано в отдельном диалоговом
   окне. Вы будете видеть это окно при каждом подключении или только при
   первом подключении, в зависимости от конфигурации сервера.

### Предупреждение о безопасности подключения

Если вы подключаетесь к серверу без действительного SSL-сертификата, вы
получите предупреждение о безопасности подключения.

Это может означать, что данное соединение небезопасно. Если вы доверяете
отпечатку сертификата этого сервера, то можете нажать «Подключение», чтобы
подключиться к нему один раз, или «Подключиться и больше не спрашивать про
этот сервер», чтобы подключиться и сохранить отпечаток сертификата.

## Прямые подключения

Опция «Сервер» в диалоговом окне «Подключение» позволяет установить прямое
соединение между компьютерами без использования удалённого управляющего
сервера.

После выбора радиокнопки «Сервер» выберите режим управления, в котором
будете подключаться.

Другой человек будет подключаться к вам, используя режим управления,
отличный от вашего.

После того, как режим управления выбран, вы можете использовать кнопку
«Получить внешний IP-адрес», чтобы получить его, и убедиться, что порт,
указанный в поле «Порт», перенаправляется правильно. Если на вашем
маршрутизаторе включена служба UPnP, то вы можете с её помощью перенаправить
выбранный порт до проверки его доступности.

Если сервер проверки обнаруживает, что ваш порт (по умолчанию 6837) закрыт,
то появится соответствующее предупреждение.

Перенаправьте ваш порт и попробуйте снова. Также убедитесь, что процесс NVDA
разрешён в брандмауэре Windows.

Примечание: процесс перенаправления портов, включения UPnP или настройки
брандмауэра Windows выходит за рамки данного документа. Пожалуйста,
обратитесь к документации вашего маршрутизатора для получения дальнейших
инструкций.

Придумайте и введите ключ в поле «Ключ» или нажмите кнопку «Создать
ключ». Другому человеку для подключения будет нужен ваш внешний IP-адрес
вместе с ключом. Если вы в поле «Порт» указали порт отличный от порта по
умолчанию (6837), то убедитесь, что другой человек добавляет ваш порт к
адресу сервера в формате &lt;внешний ip&gt;:&lt;порт&gt;.

Если вы хотите перенаправить выбранный порт с помощью UPnP, установите
флажок «Использовать UPnP для перенаправления этого порта (если возможно)».

После нажатия кнопки OK, вы будете готовы принимать входящие
подключения. Когда другой человек подключится, вы сможете использовать
TeleNVDA обычным образом.

## Управление удалённым компьютером

Когда сеанс установлен, пользователь управляющего компьютера может нажать
клавишу F11 для начала управления удалённым компьютером, посредством
использования клавиатурного или брайлевского ввода. Эта клавиша может быть
переназначена в диалоге NVDA «Жесты ввода».

Когда NVDA скажет «Управление удалённым компьютером», то нажимаемые вами
клавиши клавиатуры и брайлевского дисплея будут передаваться на удалённый
компьютер. Кроме того, если на управляющем компьютере используется
брайлевский дисплей, то на нём будет отображаться информация с удалённого
компьютера. Для остановки передачи клавиш и возврата к управлению локальным
компьютером, снова нажмите клавишу F11.

Для лучшей совместимости убедитесь, что раскладки клавиатуры на обоих
компьютерах совпадают.

## Ссылка на сеанс удалённого доступа

Чтобы получить ссылку для упрощённого подключения другого человека к вашей
сессии TeleNVDA, в подменю «Удалённое управление» активируйте пункт
«Скопировать ссылку на удалённый сеанс». Вы также можете назначить свободный
жест в диалоге «Жесты ввода», чтобы ускорить эту задачу.

Вы можете выбрать один из двух форматов ссылок. Первый совместим как с NVDA
Remote, так и с TeleNVDA, и на данный момент является наиболее
рекомендуемым. Второй совместим только с TeleNVDA.

Если ваш компьютер является управляющим, то эта ссылка позволит подключить
другой компьютер в качестве управляемого.

Если же ваш компьютер настроен как управляемый, то любой получатель данной
ссылки сможет управлять им.

Многие приложения позволяют пользователю автоматически активировать эту
ссылку, но если она не работает в каком-то приложении, то её можно
скопировать в буфер обмена и запустить из диалога «Выполнить» (Windows+R).

Обратите внимание, что ссылка на удалённый сеанс может не работать, если вы
копируете её с сервера, работающего в режиме прямого подключения.

## Отправка Control+Alt+Del на управляемый компьютер

При управлении удалённым компьютером, невозможно использовать комбинацию
клавиш Control+Alt+Del простым её нажатием, поскольку она всё равно будет
перехвачена системой управляющего компьютера.

Если вам требуется нажать на удалённом компьютере сочетание клавиш
Control+Alt+Del, то на управляющем компьютере откройте меню NVDA → Сервис →
Удалённое управление и активируйте пункт «Отправить Control+Alt+Del».

## Отправка клавиши переключения между локальным и удалённым компьютером

Обычно, когда вы нажимаете клавишу переключения между локальным и удалённым
компьютером, она выполняет данную функцию, но сама не передаётся на
удалённый компьютер.

Если вам требуется отправить эту клавишу или любой другой жест на удалённый
компьютер, то вы можете сделать это с помощью вызова команды игнорирования
нажатия следующей клавиши на управляющем компьютере.

По умолчанию на эту команду назначено сочетание клавиш Control+F11. Этот
жест можно изменить в диалоге NVDA «Жесты ввода».

При вызове этой команды следующее нажатие будет проигнорировано и отправлено
на удалённый компьютер как есть, даже если это сам жест активации команды
игнорирования. Как только это нажатие будет отправлено, оно вернётся к
обычному своему поведению.

## Автоматическая установка сеанса удалённого доступа при запуске NVDA

Иногда может потребоваться управление одним из ваших компьютеров
удалённо. Это особенно полезно, если вы путешествуете и хотите использовать
свой домашний компьютер с ноутбука. Или вы можете управлять компьютером в
одной комнате вашего дома, сидя за другим ПК. Небольшая предварительная
подготовка делает это возможным и удобным.

1. Откройте меню NVDA → Сервис → Удалённое управление → Параметры...
2. Установите флажок «Автоматически подключаться к управляющему серверу при
   запуске NVDA».
3. В первом наборе радиокнопок выберите, следует ли использовать для
   подключения удалённый или локальный управляющий сервер. Если вы выберите
   локальный сервер, то можете попробовать перенаправить порт с помощью
   UPnP, установив соответствующий флажок.
4. Во второй паре радиокнопок выберите «Разрешить управление этим
   компьютером».
5. Если вы используете локальный управляющий сервер, вы должны убедиться,
   что порт управляемого компьютера указанный в поле «Порт» (по умолчанию
   6837) открыт для приёма подключений от управляющих компьютеров.
6. Если вы хотите использовать удалённый управляющий сервер, заполните поля
   «Адрес сервера» и «Ключ» и нажмите кнопку OK. Кнопка автоматического
   создания ключа здесь недоступна. Лучше всего придумать ключ, который вы
   сможете запомнить и легко использовать его из любого удалённого места.

В качестве дополнительной возможности, вы можете настроить автоматическое
подключение TeleNVDA к локальному или удалённому управляющему серверу в
режиме управляющего компьютера. Для этого во втором наборе радиокнопок
выберите «Управлять другим компьютером».

Примечание: Настройки автоподключения к управляющему серверу в диалоге
«Параметры» применяются только после перезагрузки NVDA.

## Отключение речи и звуков с удалённого компьютера

Если вы не хотите слышать речь и стандартные звуки NVDA с управляемого
компьютера, то просто откройте меню NVDA → Сервис → Удалённое управление и
активируйте пункт «Отключить удалённую речь и звуки». Обратите внимание, что
эта опция не отключает удаленный брайлевский вывод на управляющем
компьютере.

## Завершение сеанса удалённого управления

Для завершения удалённого сеанса, выполните следующие действия:

1. На управляющем компьютере нажмите F11 для прекращения управления
   удалённым компьютером. Вы должны услышать или прочитать на брайлевском
   дисплее сообщение «Управление локальным компьютером», если вместо этого
   вы слышите или читаете сообщение «Управление удалённым компьютером», то
   нажмите F11 ещё раз.
2. Откройте меню NVDA → Сервис → Удалённое управление и нажмите Enter на
   пункте «Отключиться».

Кроме того, вы можете нажать NVDA+Alt+PageDown, чтобы более оперативно
разорвать сеанс. Этот жест можно изменить в диалоге NVDA «Жесты
ввода». Чтобы обезопасить другой компьютер, вы можете нажать это сочетание
во время управления удалённым компьютером, чтобы первым отключить его от
удалённого сеанса.

## Передача буфера обмена

Пункт «Передать буфер обмена» в подменю «Удалённое управление» позволяет вам
в удалённом сеансе передавать текст из буфера обмена между подключёнными
компьютерами.

При его активации, любой текст из буфера обмена управляющего компьютера
будет передан в буфер обмена управляемого и наоборот.

## Отправка файлов

Опция «Отправить файл» в меню «Удалённое управление» позволяет отправлять
небольшие файлы всем участникам сеанса, включая контролируемый
компьютер. Обратите внимание, что отправлять можно файлы размером не более
10 МБ. Отправка и получение файлов на защищённых экранах запрещена.

Также обратите внимание, что отправка файлов может потреблять слишком много
сетевого трафика на сервере, в зависимости от размера файла, числа
компьютеров, подключенных к одному сеансу, и количества отправленных
файлов. Свяжитесь с администратором вашего сервера и узнайте, оплачивается
ли трафик. В этом случае рассмотрите возможность использования другой
платформы для обмена файлами.

Когда файл будет получен на удалённых компьютерах, появится стандартное
диалоговое окно «Сохранить как», позволяющее выбрать, где сохранить файл.

## Настройка TeleNVDA для работы на безопасном рабочем столе

Для работы TeleNVDA на безопасном рабочем столе, дополнение должно быть
установлено в NVDA, которая запускается на защищённых экранах.

1. Откройте меню NVDA → Параметры → Настройки...
2. В открывшимся диалоге настроек, в категории «Общие», нажмите кнопку
   «Использовать последнюю сохранённую конфигурацию на экране входа в
   систему и на других защищённых экранах (требуются права администратора)».
3. Ответьте «Да» на вопросы, связанные с копированием настроек и
   плагинов. Также ответьте на вопросы контроля учётных записей, которые
   могут появиться.
4. Когда конфигурация будет скопирована, нажмите кнопку OK, чтобы закрыть
   диалог копирования настроек. Следом ещё раз нажмите OK для закрытия
   диалога настроек NVDA.

После установки TeleNVDA для работы на безопасном рабочем столе, при
переходе управляемого компьютера на защищённый экран (например в окно
контроля учётных записей), вы будете иметь на управляющем компьютере речевой
и брайлевский вывод.

## Удаление отпечатков доверенных SSL-сертификатов

Если вы больше не хотите доверять отпечаткам SSL-сертификатов серверов,
которые вы сохранили как доверенные, то можете удалить их все сразу, нажав
кнопку «Удалить все отпечатки доверенных сертификатов» в диалоговом окне
«Параметры».

## Использование пользовательского сервиса проверки портов

По умолчанию TeleNVDA проверяет открытые порты с помощью службы,
предоставляемой испанским сообществом NVDA. Вы можете изменить URL-адрес
службы в диалоговом окне «Параметры». Убедитесь, что порт для проверки
является частью пользовательского URL-адреса, а результат возвращается в
ожидаемом формате. Пример скрипта проверки портов распространяется в
репозитории TeleNVDA, так что при желании вы можете запустить свою
собственную копию.

## Внесение изменений в TeleNVDA

Этот проект распространяется под стандартной общественной лицензией GNU
версии 2 или выше. Вы можете клонировать [этот репозиторий][2], чтобы внести
свои изменения в TeleNVDA, при условии, что вы прочитали, поняли и
соблюдаете условия лицензии. Модуль MiniUPNP распространяется под
трёхпунктной лицензией BSD.

### Сторонние зависимости

Их можно установить с помощью pip:

* Markdown
* scons

Чтобы создать исполняемый файл обработчика URL-адресов, вам потребуется
Visual Studio 2019 или более поздняя версия.

### Создание распространяемого пакета дополнения

1. Откройте командную строку и перейдите в корневой каталог [этого
   репозитория][2]
2. Выполните команду **scons**. Созданное дополнение, если не произошло
   никаких ошибок, будет размещено в текущем каталоге.

[[!tag dev stable]]

[1]: https://www.nvaccess.org/addonStore/legacy?file=TeleNVDA

[2]: https://github.com/nvda-es/TeleNVDA
