# TeleNVDA #

* Автори: Асоціація іспаномовної спільноти NVDA та інші
  учасники. Оригінальна робота Tyler Spivey і Christopher Toth
* Сумісність з NVDA: 2019.3 і пізніші
* Завантажити [стабільну версію][1]

Примітка: щоб полегшити завантаження для користувачів, які потребують
допомоги або навчання і мають обмежені комп'ютерні навички, ми надаємо
альтернативне посилання на останню стабільну версію, яке легко запам'ятати і
яким легко ділитися. Ви можете перейти на
[nvda.es/tele](https://nvda.es/tele) і завантажити додаток безпосередньо,
без проміжних веб-сторінок.

Ласкаво просимо до додатка TeleNVDA, який дозволить вам підключатися до
іншого комп’ютера, на якому запущено безкоштовну програму зчитування екрана
NVDA. За допомогою цього додатка ви можете підключитися до комп’ютера іншої
особи або дозволити довіреній особі підключитися до вашої системи для
виконання планового технічного обслуговування, діагностики проблеми або
навчання. Цей додаток є модифікованою версією [додатка NVDA
Remote](https://nvdaremote.com) і підтримується іспанською спільнотою
NVDA. Він повністю сумісний із NVDA Remote. Ось поточні відмінності:

* Параметр дозволяє блокувати віддалені мовленнєві команди, відмінні від
  тексту.
* Покращена підтримка проксі-серверів і прихованих служб TOR (потрібен
  [додаток підтримки
  проксі](https://addons.nvda-project.org/addons/proxy.uk.html))].
* Можливість змінити клавішу f11 на інший жест. Тепер це працює як звичайний
  сценарій, тому ви можете призначати жести в діалозі «Жести вводу».
* Можливість повністю ігнорувати наступний жест, це корисно, якщо вам
  потрібно надіслати на віддалений компьютер жест, який використовується для
  перемикання між хостом і віддаленим комп’ютером.
* Можливість обмінюватися невеликими файлами (до 10 МБ) між користувачами,
  підключеними до однієї сесії.
* Можливість переадресації портів через UPNP.
* Можливість використовувати власну службу перевірки портів.
* Деякі налаштування графічного інтерфейсу.
* Кілька виправлень.

## Перед тим, як почати

Вам потрібно буде встановити NVDA на обох комп'ютерах і отримати додаток
TeleNVDA.

Встановлення як NVDA, так і додатка є стандартним. Якщо вам потрібна
додаткова інформація, її можна знайти в посібнику користувача NVDA.

## Оновлення

Під час оновлення додатка, якщо ви встановили TeleNVDA для роботи на
захищених екранах, рекомендується також оновити копію додатка, що працює на
таких екранах.

Для цього спочатку оновіть наявний додаток. Потім відкрийте меню NVDA,
параметри, налаштування, загальні, і натисніть кнопку "Використовувати
останні збережені налаштування під час входу й читання захищених екранів
(потрібні права адміністратора)".

## Запуск віддаленого сеансу через сервер ретрансляції

### На керованому комп’ютері

1. Відкрийте меню NVDA, Інструменти, Віддалене керування, З'єднати.
2. Оберіть радіокнопку "клієнт" у першій групі радіокнопок.
3. Оберіть радіокнопку "Дозволити керувати цим комп'ютером" у другій групі
   радіокнопок.
4. У полі «Сервер», введіть адресу сервера, з яким хочете з’єднатись,
   наприклад, remote.nvda.es. Коли певний сервер використовує альтернативний
   порт, ви маєте ввести адресу сервера у форматі
   &lt;сервер&gt;:&lt;порт&gt;, наприклад, remote.nvda.es:1234. Якщо ви
   підключаєтеся до IPV6-адреси, введіть її у квадратних дужках, наприклад
   [2603:1020:800:2::32].
5. Введіть ключ у поле введення ключа або натисніть кнопку "Створити
   ключ". Ключ використовуватиметься тим, хто керує вашим
   комп'ютером. Керований комп’ютер і всі, хто підключатиметься до нього,
   повинні використовувати однаковий ключ.
6. Натисніть «Гаразд». Після цього ви почуєте звуковий сигнал і будете
   підключені. Якщо на сервері є повідомлення дня, воно буде показано в
   діалозі. Ви будете бачити цей діалог при кожному підключенні або тільки
   при першому, в залежності від конфігурації сервера.

### На машині, яка буде керівним комп'ютером

1. Відкрийте меню NVDA, Інструменти, Віддалене керування, З'єднати.
2. Оберіть радіокнопку "клієнт" у першій групі радіокнопок.
3. У другій групі радіокнопок виберіть «Керувати іншим комп’ютером».
4. У полі «Сервер», введіть адресу сервера, з яким хочете з’єднатись,
   наприклад, remote.nvda.es. Коли певний сервер використовує альтернативний
   порт, ви маєте ввести адресу сервера у форматі
   &lt;сервер&gt;:&lt;порт&gt;, наприклад, remote.nvda.es:1234. Якщо ви
   підключаєтеся до IPV6-адреси, введіть її у квадратних дужках, наприклад
   [2603:1020:800:2::32].
5. Введіть ключ у поле введення ключа або натисніть кнопку "Створити
   ключ". Керований комп’ютер і всі, хто підключатиметься до нього, повинні
   використовувати однаковий ключ.
6. Натисніть «Гаразд». Після цього ви почуєте звуковий сигнал і будете
   підключені. Якщо на сервері є повідомлення дня, воно буде показано в
   діалозі. Ви будете бачити цей діалог при кожному підключенні або тільки
   при першому, в залежності від конфігурації сервера.

### Застереження щодо безпеки з'єднання

Якщо ви підключаєтеся до сервера без чинного SSL-сертифіката, ви отримаєте
застереження щодо безпеки з'єднання.

Це може означати, що ваше з'єднання незахищене. Якщо ви довіряєте цьому
серверу, ви можете натиснути "Під'єднатися", щоб встановити з'єднання лише
один раз, або "Під'єднатися й більше не запитувати для цього сервера", щоб
встановити з'єднання і додати його до списку надійних серверів.

## Прямі з’єднання

Параметр «Сервер» у діалозі «З'єднання» дає змогу встановити пряме з’єднання
з іншим комп’ютером.

Вибравши це, виберіть, у якому режимі буде кінець з’єднання.

Інша особа з'єднається з вами, використовуючи режим, відмінний від вашого.

Обравши режим, ви можете скористатися кнопкою «Отримати зовнішню IP-адресу»,
щоб знайти вашу IP-адресу й переконатися, що порт, вказаний у полі «Порт»,
переспрямовується правильно. Якщо це ввімкнено на вашому маршрутизаторі, ви
можете переадресувати порт за допомогою UPNP, перш ніж виконувати перевірку
порту.

Якщо служба перевірки портів виявить, що ваш порт (типово 6837) недоступний,
з'явиться попередження.

Переспрямуйте порт і спробуйте ще раз. Також переконайтеся, що процес NVDA
дозволено у брандмауері Windows.

Примітка: Процес переспрямування портів, увімкнення UPNP та налаштування
брандмауера Windows виходить за рамки цього документа. Будь ласка,
зверніться до документації вашого маршрутизатора для отримання подальших
інструкцій.

Введіть ключ у поле ключа або натисніть кнопку «Створити ключ». Для
підключення іншій людині знадобиться ваш зовнішній IP разом з ключем. Якщо у
полі "Порт" ви вказали порт, відмінний від типового (6837), переконайтеся,
що інша особа теж додала альтернативний порт до адреси сервера у форматі
&lt;зовнішня IP-адреса&gt;:&lt;порт&gt;.

Якщо ви хочете переспрямувати вибраний порт із використанням UPNP, позначте
прапорець «Використовувати UPNP для переспрямування цього порту якщо
можливо».

Після натискання кнопки «Гаразд» вас буде підключено. Коли інший користувач
підключиться, ви зможете використовувати TeleNVDA у звичайному режимі.

## Керування віддаленим комп’ютером

Коли з'єднання встановлене, користувач керівного комп'ютера може натиснути
клавішу f11, щоб почати керувати віддаленим пристроєм (наприклад, надсилаючи
команди клавіатури або вводячи текст шрифтом Брайля). Цей жест можна змінити
в діалозі «Жести вводу» NVDA.

Коли NVDA говорить: "Керування віддаленим комп'ютером", команди клавіатури
та дисплея Брайля, які ви натискаєте, передаватимуться на віддалений
комп'ютер.

Для найкращої сумісності переконайтеся, що розкладки клавіатури на обох
пристроях збігаються.

## Ділимося своїм сеансом

Щоб поділитися посиланням, аби хтось інший міг легко приєднатися до вашого
сеансу TeleNVDA, виберіть "Копіювати посилання" в меню віддаленого
керування. LЩоб пришвидшити виконання цього завдання, призначте на нього
жест в діалозі «Жести вводу».

Ви можете вибрати один з двох форматів посилань. Перший сумісний як з NVDA
Remote, так і з TeleNVDA, і наразі є найбільш рекомендованим. Другий формат
сумісний лише з TeleNVDA.

Якщо ви під'єднані як керівний комп’ютер, це посилання дозволить комусь
іншому під’єднатися і бути керованим.

Якщо замість цього ви налаштували свій комп'ютер на керування, посилання
дозволить людям, з якими ви ділитеся ним, керувати вашим комп’ютером.

Багато програм дадуть змогу користувачам автоматично активувати це
посилання, але якщо воно не запускається з певної програми, його можна
скопіювати до буфера обміну та запустити з діалогу "Виконати" (windows+r).

Зауважте, що спільне посилання може не працювати, якщо ви скопіюєте його з
сервера, який працює в режимі прямого з'єднання.

## Надіслати Ctrl+Alt+Del

При надсиланні клавіш неможливо відправити комбінацію CTRL+Alt+del звичайним
натисканням.

Якщо потрібно відправити CTRL+Alt+del, а віддалена система знаходиться на
захищеному робочому столі, використовуйте цю команду.

## Надіслати жест перемикання між локальним і віддаленим комп'ютером

Зазвичай, коли ви натискаєте призначений жест для перемикання між локальним
і віддаленим комп'ютером, він не надсилається на віддалений комп'ютер, а
перемикається між локальним і віддаленим комп'ютером.

Якщо вам потрібно надіслати цей або будь-який інший жест на віддалений
комп'ютер, ви можете змінити цю поведінку для наступного жесту, активувавши
сценарій ігнорування наступного жесту.

Початково цей сценарій призначається клавіші control + f11. Цей жест можна
змінити в діалозі жести вводу NVDA.

Під час виклику цього сценарію наступний жест ігноруватиметься та
надсилатиметься на віддалений комп’ютер, включно з жестом для активації
сценарію ігнорування наступного жесту. Після надсилання наступного жесту він
повернеться до звичайної поведінки.

## Віддалене керування комп'ютером без нагляду

Іноді може виникнути потреба у віддаленому керуванні одним із власних
комп'ютерів. Це особливо корисно, якщо ви подорожуєте і хочете керувати
домашнім комп'ютером зі свого ноутбука. Або, можливо, ви захочете керувати
комп'ютером в одній кімнаті вашого будинку, сидячи на вулиці з іншим
ПК. Невелика попередня підготовка робить це зручним і можливим.

1. Відкрийте меню NVDA, оберіть "Інструменти", далі - "Віддалене
   керування". Нарешті, натисніть Enter на пункті "Параметри...".
2. Позначте прапорець "Автопідключення до керівного сервера під час
   запуску".
3. Виберіть, чи використовувати віддалений сервер ретрансляції, чи локально
   розміщувати з'єднання. Якщо ви вирішите розміщувати з'єднання на сервері,
   ви можете спробувати переспрямувати порти за допомогою UPNP, встановивши
   відповідний прапорець.
4. Оберіть радіокнопку "Дозволити керувати цим комп'ютером" у другій групі
   радіокнопок.
5. Якщо ви самі встановлюєте з'єднання, вам необхідно переконатися, що порт,
   введений в поле порту (типово 6837) на керованому комп'ютері, може бути
   доступний з керівних комп'ютерів.
6. Якщо ви бажаєте використовувати сервер ретрансляції (віддалений сервер),
   заповніть обидва поля "Адреса сервера" і "Ключ", після чого натисніть
   кнопку "Гаразд". Опція "Створити ключ" в цій ситуації
   недоступна. Найкраще придумати ключ, який ви запам'ятаєте, щоб ви могли
   легко використовувати його з будь-якого віддаленого місця.

Для розширеного застосування ви також можете налаштувати NVDA Remote на
автоматичне підключення до локального або віддаленого сервера ретрансляції в
режимі керівного пристрою. Якщо ви цього бажаєте, виберіть "Керувати іншим
комп'ютером" у другому наборі радіокнопок.

Примітка: Параметри, пов'язані з автоматичним підключенням під час запуску в
діалозі параметрів, не будуть застосовані до перезавантаження NVDA.

## Вимкнення мовлення на віддаленому комп'ютері

Якщо ви не бажаєте чути мовлення й стандартні звуки NVDA з керованого
комп'ютера, просто перейдіть до меню NVDA, "Інструменти" та "Віддалене
керування". Стрілкою вниз виберіть пункт "Вимкнути звук віддаленого
комп'ютера" та натисніть клавішу Enter. Зверніть увагу, що ця опція не
відключає виведення віддаленого вмісту на дисплей Брайля керівного
комп'ютера, коли керівний комп'ютер надсилає команди.

## Завершення віддаленого сеансу

Для завершення віддаленого сеансу виконайте таке:

1. На керівному комп'ютері натисніть F11, щоб припинити керування віддаленим
   комп'ютером. Ви повинні почути або прочитати повідомлення: "Керування
   локальним комп'ютером". Якщо натомість ви почуєте або прочитаєте
   повідомлення про те, що ви керуєте віддаленим комп'ютером, то натисніть
   F11 ще раз.
2. Відкрийте меню NVDA, оберіть "Інструменти", далі - "Віддалене керування"
   та активуйте пункт "Перервати".

Також ви можете натиснути NVDA+alt+сторінка вниз, щоб безпосередньо
розірвати сеанс. Цей жест можна змінити в діалозі «Жести вводу» NVDA. Щоб
захистити іншу сторону, ви можете натиснути цей жест під час надсилання
клавіш для від'єднання віддаленого комп'ютера.

## Передача буфера обміну

Опція "Передати буфер обміну" в меню "Віддалене керування" дає змогу
надіслати текст з буфера обміну.

При активації цієї опції будь-який текст з буфера обміну буде передано на
інші комп'ютери.

## Надсилання файлів

Опція «Надіслати файл» у віддаленому меню дозволяє надсилати невеликі файли
всім учасникам сеансу, включно з керованим комп'ютером. Зверніть увагу, що
ви можете надсилати файли розміром не більше 10 МБ. Надсилання або отримання
файлів на захищених екранах заборонено.

Також зауважте, що надсилання файлів може споживати занадто багато
мережевого трафіку на сервері, залежно від розміру файлу, кількості
комп'ютерів, підключених до одного сеансу, та кількості надісланих
файлів. Зверніться до адміністратора вашого сервера й запитайте, чи
тарифікується трафік. У такому випадку розгляньте можливість використання
іншої платформи для обміну файлами.

Коли файл буде отримано на віддаленому комп’ютері, з'явиться діалог Зберегти
як, в якому ви зможете вибрати місце збереження файлу.

## Налаштування NVDA Remote для роботи на захищеному робочому столі

Для того, щоб TeleNVDA працював на захищеному робочому столі, додаток
повинен бути встановлений у NVDA, що працює на захищеному робочому столі.

1. В меню NVDA перейдіть до підменю "Параметри", далі оберіть
   "Налаштування...".
2. Рухайтеся клавішею tab до кнопки «"Використовувати останні збережені
   налаштування під час входу й читання захищених екранів (потрібні права
   адміністратора)» і натисніть клавішу Enter.
3. Відповісти "Так" на запити щодо копіювання налаштувань та копіювання
   додатків, а також відповісти на запит служби захисту користувачів, що
   може з'явитися.
4. Коли налаштування буде скопійовано, натисніть кнопку «Гаразд», щоб
   закрити діалог копіювання.

Після встановлення TeleNVDA на захищений робочий стіл, якщо в цей момент
вами керують у віддаленому сеансі, ви матимете доступ до захищеного робочого
столу за допомогою мовлення та шрифту Брайля при перемиканні на нього.

## Видалення цифрових відбитків SSL-сертифікатів

Якщо ви більше не хочете довіряти серверам, які ви раніше додали до
надійних, ви можете видалити всі цифрові відбитки серверів, натиснувши
кнопку «Видалення всіх надійних відбитків» у діалозі "Параметри".

## Використання власної служби перевірки портів

Початково TeleNVDA перевіряє відкриті порти за допомогою сервісу іспанської
спільноти NVDA. Ви можете змінити адресу сервісу за допомогою діалогу
параметрів. Переконайтеся, що порт, який перевіряється, є частиною
користувацької URL-адреси, а результати перевірки повертаються в очікуваному
форматі. Зразок сценарію перевірки портів розміщено у репозиторії TeleNVDA,
тому ви можете створити власну копію, якщо бажаєте.

## Внесення змін у TeleNVDA

Цей проєкт поширюється на умовах ліцензії GNU General Public License, версія
2 або новіша. Ви можете клонувати [цей репозиторій][2] для внесення змін до
TeleNVDA за умови, що ви прочитали, зрозуміли і поважаєте умови
ліцензії. Модуль MiniUPNP ліцензовано за ліцензією BSD-3.

### Сторонні залежності

Наступні модулі можуть бути встановлені за допомогою pip:

* Markdown
* scons

Для створення виконуваного файлу обробника URL вам потрібна Visual Studio
2019 або новішої версії.

### Щоб запакувати доповнення для розповсюдження:

1. Відкрийте командний рядок та перейдіть до кореневого каталогу [цього
   репозиторію][2]
2. Запустіть команду scons. Створений додаток, якщо не виникне помилок, буде
   розміщений в поточному каталозі.

[[!tag dev stable]]

[1]: https://www.nvaccess.org/addonStore/legacy?file=TeleNVDA

[2]: https://github.com/nvda-es/TeleNVDA
