# TeleNVDA 远程协助 #

* 作者： NVDA 西班牙社区和其他贡献者。原作者Tyler Spivey、Christopher Toth
* NVDA 兼容性：2019.3 及更高版本
* 下载 [稳定版][1]

注意：为了使需要帮助的用户更容易下载，我们提供了易于记忆且便于传播分享的最新稳定版链接。您可以前往
[nvda.es/tele](https://nvda.es/tele) 直接下载插件，无需中间网页。

欢迎使用NVDA
远程协助插件，此插件允许您连接到运行免费NVDA屏幕阅读器的另一台计算机。无论两台电脑就在一间屋里面，还是在地球两端，都没有区别。连接很简单，只需要几步操作。您可以连接到其他人的计算机，或允许受信任的人连接到您的系统以执行日常维护，诊断问题或提供培训。
该插件是 [NVDA 远程插件](https://nvdaremote.com) 的修改版，由 NVDA 西班牙社区维护。该插件与 NVDA
Remote 完全兼容。以下是与 NVDA Remote 的差异：

* 选项： 在控制对方计算机时处理语音命令。
* 改进了对代理服务器和 TOR 隐藏服务的支持（需
  [代理支持插件](https://addons.nvda-project.org/addons/proxy.zh_CN.html)）。
* 支持将 f11 键更改为其他快捷键。目前，这是一个通用手势，因此您可以在“按键与手势”对话框中分配其他快捷键。
* 支持完全将下一个首饰交给被控方处理，如果您希望把用于在控制方和被控方之间切换的快捷键发送到被控方，则该特性很有用。
* 支持在连接了同一会话的用户之间传送小文件（最多 10 MB）。
* 支持通过 UPNP 转发端口。
* 支持使用自定义端口检测服务。
* 一些 GUI 方面的调整。
* 修复了一些错误。

## 使用之前

您需要在两台计算机上安装NVDA 和 TeleNVDA 远程协助插件（下称“远程协助插件”）。

NVDA 和远程协助插件的安装都是基本操作。如果您不会，可以在NVDA的用户指南中找到相关的帮助。

## 更新

更新插件时，如果已在安全桌面上安装了远程协助插件，则建议您也在安全桌面上更新副本。

请先更新现有的插件。然后打开NVDA菜单 > 选项 > 设置 > 常规，并按下“应用以保存的配置到欢迎界面和其他安全界面（需要管理员权限）”的按钮。

## 通过中继服务器开始远程会话

### 在被控端的计算机上

1. 打开NVDA菜单 > 工具 > 远程 > 连接。
2. 在第一组单选按钮中选择“客户端”。
3. 在第二组单选按钮中选择允许此计算机被控制。
4. 在主机编辑框中，输入要连接的服务器的主机，例如 nr.nvdacn.com。当某服务器使用其他端口时，您可以用 host:port
   的形式填写主机，例如 nvdaremote.com:1234。
5. 在密钥编辑框中输入一个密要，或按下生成密钥按钮。   - 这个密钥是其他人用来控制您的计算机的关键凭证。   -
   被控端与控制端需要使用相同的密钥。
6. 按确认。完成后，您将听到提示音，这时就已经连接了。如果服务器包含每日信息，会在对话框中显示。每次连接或仅在第一次连接时，您会看到此对话框，具体取决于中继服务器的设置。

### 在控制端的计算机上

1. 打开NVDA菜单 > 工具 > 远程 > 连接。
2. 在第一组单选按钮中选择“客户端”。
3. 在第二组单选按钮中选择控制另一台计算机。
4. 在主机编辑框中，输入要连接的服务器的主机，例如 nr.nvdacn.com。当某服务器使用其他端口时，您可以用 host:port
   的形式填写主机，例如 nvdaremote.com:1234。
5. 在密钥编辑框中输入一个密要，或按下生成密钥按钮。
6. 按确认。完成后，您将听到提示音，这时就已经连接了。如果服务器包含每日信息，会在对话框中显示。每次连接或仅在第一次连接时，您会看到此对话框，具体取决于中继服务器的设置。

### 连接安全警告

如果您连接的服务器没有有效 SSL 证书，您会收到一条连接安全警告。

这可能意味着您的连接不安全。如果您信任此服务器指纹，您可以点击“连接”按钮进行临时连接，或点击“连接且不再询问该服务器”连接并保存指纹。

## 直接连接

“连接”对话框中的“服务器”选项可以让您设置直接连接。

选择此项后，选择您的连接模式（控制另一台计算机还是允许这台计算机被控制）。

对方应该用相反的方式与您建立连接。

选择模式后，您可以使用“获取公网 IP”按钮获取公网 IP地址

如果端口检测服务检测到您的端口（默认为 6837）无法访问，则会显示提示信息。

请转发您的端口，然后重试。另外，请确保允许 NVDA 进程通过 Windows 防火墙。

注意：转发端口、启用 UPNP 或配置 Windows 防火墙的步骤已超出了本文档的范畴。请参阅路由器随附的信息以获取进一步的帮助。

在密钥编辑框中输入密钥，或按下生成按钮。对方需要您的公网
IP和密钥。如果您在端口编辑框中输入了默认端口（6837）以外的端口，请确保另一方将指定的端口正确添加到了主机地址，格式为 公网ip地址:端口。

如果要使用 UPNP 转发所选端口，请选中“使用 UPNP 转发此端口（如果可能）”复选框。

按下确认后，就连接成功了。在对方连接过程中，您可以正常使用远程协助。

## 控制远程计算机

一旦两方连接成功，控制方可以按f11开始控制远程计算机（如，发送键盘按键或盲文输入）。

当NVDA朗读“控制远程计算机”时，您执行的键盘按键和盲文输入将发送到远程计算机。此外，当控制方使用盲文点显器时，也会在点显器上显示来自远程计算机的信息。再次按
f11 可停止控制并切换回本地计算机。您可以在“按键与手势”对话框中分配其他快捷键。

为获得最佳的兼容性，请确保控制方与被控方的 NVDA 使用了相同的键盘布局。

## 分享您的会话

要共享链接以便其他人可以轻松加入您的NVDA 远程会话，请在“远程”菜单中选择“复制链接”。您也可以为此功能分配一个快捷键，从而提高操作效率。

您可以在两种链接格式之间进行选择。第一个同时兼容 NVDA 远程和 TeleNVDA，是目前最推荐的。第二个仅与 TeleNVDA 兼容。

如果您作为控制方，此链接可以让其他人的计算机被控制。

如果您作为被控方，则此链接可以让其他人来控制您的计算机。

得到链接的一方，可以将链接复制到剪贴板，然后使用 Windows + R 打开运行对话框，粘贴以 nvdaremote://
开头的链接并确定，随后按照提示可以控制对方的计算机或者允许对方控制自己的计算机。

请注意，如果从以直接连接模式运行的服务器端复制共享链接，则该共享链接可能无效。

## 发送 Ctrl + Alt + Del

在控制另一台计算机的过程中，无法正常发送 CTRL + Alt + del 快捷键。

如果需要发送CTRL + Alt + del，使远程计算机进入安全桌面，请使用此命令。

## 发送用于在控制方和被控方之间切换的快捷键

通常当您按控制方和被控方之间切换的快捷键时，不会发送到被控方，因为该快捷键用于在本地计算机和远程计算机之间切换。

如果您需要将此快捷键或任何其他按键发送到被控方，您可以执行“忽略下一个按键指令，将其完全交给被控方处理”。

默认情况下，该功能分配的快捷键是 control + f11 键。您可以在“按键与手势”对话框中分配其他快捷键。

按下该快捷键，下一个按键指令会被忽略，并会原样发送到被控方，也包括这个快捷键。

## 远程控制无人值守的计算机

有时，您可能希望远程控制您自己的另一台计算机。比如您正在外面旅行，此时希望通过手边的笔记本控制家里的计算机，这就特别有用了。又或者，您就在家里，只是想控制另一个房间的计算机。仅需要进行一点额外的准备工作就可以方便地实现无人值守的远程控制。

1. 进入NVDA菜单，选择“工具”，然后选择“远程”。最后，找到“选项”按“回车键”打开远程插件的“选项对话框”。
2. 选中“启动时自动连接到控制服务器”复选框。
3. 选择是“使用远程中继服务器”还是“主控服务器”。如果您选中主控服务器，您可以选中“使用 UPNP 转发此端口（如果可能）”尝试使用 UPNP
   转发端口。
4. 在第二组单选按钮中选择允许此计算机被控制。
5. 如果您选择“主控服务器”，则要确保在端口编辑框里填入的端口可以被访问（默认端口为6837）。
6. 如果要使用中继服务器，请填写主机和密钥，按“tab键”切换到“确认”按钮，然后按下“回车键”。在这种情况下，“生成密钥”选项不可用。最好输入一个你记的住的密钥，这样你就可以从任何位置轻松使用NVDA
   远程了。

关于更高级的用法，您还可以设置为“启动后自动连接到控制服务器”，然后在第二组单选按钮中选择“控制另一台计算机”。

注意： 您需要重新启动 NVDA 来使选项对话框中配置的自动连接等选项生效。

## 远程计算机静音

如果您不想听到远程计算机的语音或 NVDA 的提醒声音，只需打开 NVDA菜单 > 工具 >
远程。下光标找到“远程计算机静音”，然后按回车键。请注意，当控制方在此状态下操作被控方计算机时，此选项不会禁用控制方点显器的远程盲文输出。

## 结束远程会话

要结束远程会话，请执行以下操作：

1. 在控制计算机上，按F11停止控制远程机器。您应该听到或在点显器上读到消息：“控制本地计算机”。如果您听到或读到“控制远程计算机”，请再按一次F11。
2. 打开NVDA菜单，然后选择工具，远程，然后找到“断开连接”案回车确认。

或者，您可以按``NVDA+alt+下翻页``直接断开连接。您可以在“按键与手势”对话框中分配其他快捷键。

## 发送剪贴板

远程菜单中的“发送剪贴板”选项允许您从剪贴板中发送文本内容。

使用该功能，剪贴板上的任何文本都会被发送到对方计算机。

## 发送文件

远程菜单中的发送文件选项可以让您向所有会话成员（包括被控机器）发送小文件。请注意，您只能发送小于 10 MB 的文件。不允许在安全屏幕上发送或接收文件。

另请注意，发送文件可能会花费中继服务器的流量，具体取决于文件大小、连接到同一会话的计算机数量以及发送的文件数量。请联系提供中继服务的服务器管理员并询问服务器流量的计费情况。如果流量收费，或非常有限，请考虑使用其他平台来传送文件。

当远程计算机收到文件时，会弹出“另存为”对话框，可以让您选择保存文件的位置。

## 配置远程协助在安全桌面上运行

若使远程协助能够在安全桌面上运行，必须在安全桌面上运行的 NVDA 中安装该远程协助插件。

1. 从NVDA菜单中，选择：选项，然后找到常规设置。
2. 选择“应用以保存的配置到欢迎界面和其他安全界面（需要管理员权限）”按钮，然后按下回车键。
3. 对有关复制设置和复制插件的提示选择“是”，并接受可能出现的“用户帐户控制”提示。
4. 复制设置后，点击“确认”按钮。按tab键再找到“确认”按钮后按回车键退出对话框。

在安全桌面上安装 NVDA 远程后，您在远程控制过程中，切换到安全桌面时，您也会收到语音和盲文输出。

## 清除 SSL 证书指纹

如果您不再信任已信任的服务器指纹，您可以在“选项”对话框中点击“移除所有已信任的指纹”按钮来清除所有信任过的指纹。

## 自定义端口检测服务

默认情况下，TeleNVDA 使用 NVDA 西班牙社区提供的服务检测开放的端口。您可以从选项对话框更改用于端口检测的服务
URL。确保要检查的端口是自定义 URL 的一部分，并且结果以预期格式返回。TeleNVDA 存储库中包含 Portcheck
的示例脚本，因此您可以根据需要部署自己的端口检测服务。

## 修改 TeleNVDA

该项目受 GNU 通用公共许可证第 2 版或更高版本的保护。您可以 clone [该项目][2]以对 TeleNVDA
进行改进，前提是您已阅读、理解并遵守许可条款。 MiniUPNP 模块根据 BSD-3 条款许可证获得许可。

### 第三方依赖

以下可以使用 pip 安装：

* Markdown
* scons

为了编译 URL 处理程序，您需要 Visual Studio 2019 或更高版本。

### 编译插件以供分发：

1. 打开命令行，转到[该项目][2]的目录下。
2. 执行 **scons** 命令。如果没有错误，创建的插件会放置在当前目录中。

[[!tag dev stable]]

[1]: https://www.nvaccess.org/addonStore/legacy?file=TeleNVDA

[2]: https://github.com/nvda-es/TeleNVDA
